#!/sbin/sh

ui_print "- Configuring key files..."
mkdir -p /data/ftt_temp/
unzip -qjo "$ZIPFILE" 'common/app/base.apk' -d "/data/ftt_temp/" 
mkdir -p /data/FastTurbo_Custom/
unzip -qjo "$ZIPFILE" 'common/config/boost_list_a.txt' -d "/data/FastTurbo_Custom/" 
unzip -qjo "$ZIPFILE" 'common/config/boost_list_b.txt' -d "/data/FastTurbo_Custom/" 
ui_print "- Key files are configured."

INSTALL_INFO=$(pm install -r "/data/ftt_temp/base.apk")
echo "- APP Install : $INSTALL_INFO "


#建立目录
ui_print "- Configuring defult data files..."
error_info=$(cat /data/FastTurbo/done)
if [ $error_info = "0" ] ; then
rm -rf /data/FastTurbo/
fi
Path=/data
if [ ! -d $Path/FastTurbo ]; then 
 mkdir -p $Path/FastTurbo
 echo "1" > /data/FastTurbo/done 
fi;
if [ ! -d /data/FastTurbo/SmartAI/ ] ; then
mkdir -p /data/FastTurbo/SmartAI
fi
mode=$Path/FastTurbo/mode
#判断模块配置文件是否存在
if [ ! -e /data/FastTurbo/kmode ] ; then
echo "little" > /data/FastTurbo/kmode
fi
if [ ! -e /data/FastTurbo/temp_fix ] ; then
echo "false" > /data/FastTurbo/temp_fix
fi
if [ ! -e /data/FastTurbo/net_fix ] ; then
echo "false" > /data/FastTurbo/net_fix
fi
if [ ! -e /data/FastTurbo/kernel_fix ] ; then
echo "false" > /data/FastTurbo/kernel_fix
fi
if [ ! -e /data/FastTurbo/google_fix ] ; then
echo "false" > /data/FastTurbo/google_fix
fi
if [ ! -e /data/FastTurbo/prop_fix ] ; then
echo "false" > /data/FastTurbo/prop_fix
fi
if [ ! -e /data/FastTurbo/touch_fix ] ; then
echo "false" > /data/FastTurbo/touch_fix
fi
if [ ! -e /data/FastTurbo/vm_fix ] ; then
echo "false" > /data/FastTurbo/vm_fix
fi
if [ ! -e /data/FastTurbo/io_fix ] ; then
echo "false" > /data/FastTurbo/io_fix
fi
if [ ! -e /data/FastTurbo/lpl_fix ] ; then
echo "false" > /data/FastTurbo/lpl_fix
fi
if [ ! -e /data/FastTurbo/dse_fix ] ; then
echo "false" > /data/FastTurbo/dse_fix
fi
if [ ! -e /data/FastTurbo/dns_fix ] ; then
echo "false" > /data/FastTurbo/dns_fix
fi
if [ ! -e /data/FastTurbo/uksm_fix ] ; then
echo "false" > /data/FastTurbo/uksm_fix
fi
if [ ! -e /data/FastTurbo/deepsleep_fix ] ; then
echo "false" > /data/FastTurbo/deepsleep_fix
fi
if [ ! -e /data/FastTurbo/drw_fix ] ; then
echo "false" > /data/FastTurbo/drw_fix
fi
if [ ! -e /data/FastTurbo/use_eas ] ; then
echo "false" > /data/FastTurbo/use_eas
fi
if [ ! -e /data/FastTurbo/smai_mode ] ; then
echo "stop" > /data/FastTurbo/smai_mode
fi
if [ ! -e /data/FastTurbo/ram_fix ] ; then
echo "true" > /data/FastTurbo/ram_fix
fi
if [ ! -e /data/FastTurbo/mode ] ; then
echo "balance" > /data/FastTurbo/mode
echo "1024" > /data/FastTurbo/zmode
fi
if [ ! -e /data/FastTurbo/kmode ] ; then
echo "auto" > /data/FastTurbo/kmode 
fi
chmod -R 7777 /data/FastTurbo/

ui_print "- Remove TEMP Files..."
rm -rf /data/ftt_temp/
ui_print "- TEMP Files Removed."
