#!/system/bin/sh
GAME_PID=$$
echo "$GAME_PID" > /data/FastTurbo/SmartAI/game_pid
mode=$(cat /data/FastTurbo/mode)
LOG="/data/FastTurbo/SmartAI/core_info.log"
echo "false" > /data/FastTurbo/SmartAI/game_boost
echo "false" > /data/FastTurbo/SmartAI/app_boost
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
MTK="false"
case $SOC in mt*)
MTK="true"
esac
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
soc_special=$(cat /data/FastTurbo/SmartAI/soc_special)
if [ $core_num = "9" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
freq8=$(cat /data/FastTurbo/SmartAI/cpu_freq8)
freq9=$(cat /data/FastTurbo/SmartAI/cpu_freq9)
elif [ $core_num = "7" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
elif [ $core_num = "5" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
elif [ $core_num = "3" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies ] ; then
available_freq_1=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies ] ; then
available_freq_2=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies ] ; then
available_freq_3=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies ] ; then
available_freq_4=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies ] ; then
available_freq_5=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies ] ; then
available_freq_a=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies)
fi
if [ $mode = "gamexe" -o $mode = "turbo" ] ; then
 GAMEBOOST_START="false"
 while true ; do
  APP_RUNNING="false"
  BOOST_LIST="/data/FastTurbo_Custom/boost_list_a.txt"
  FOREGROUND_APP=$(su -c dumpsys window | grep mFocusedApp)
  for CHECK_APP in $(cat $BOOST_LIST) ; do
   case $FOREGROUND_APP in *"$CHECK_APP"*)
    APP_RUNNING="true"
   esac
  done
  if [ $APP_RUNNING = "true" ] ; then
   if [ $GAMEBOOST_START != "true" ] ; then
    echo "[LOG][$(date +%T)] 检测到预设程序运行,GAME BOOST生效." |  tee -a $LOG;
   fi
   echo "true" > /data/FastTurbo/SmartAI/game_boost
   GAMEBOOST_START="true"
  else
   echo "false" > /data/FastTurbo/SmartAI/game_boost
   if [ $GAMEBOOST_START = "true" ] ; then
    GAMEBOOST_START="false"
    echo "[LOG][$(date +%T)] 检测到程序退出,GAME BOOST已停止." |  tee -a $LOG;
   fi
  fi
 sleep 10
 done
elif [ $mode = "powersave" -o $mode = "balance" ] ; then
 APPBOOST_START="false"
 while true ; do
  APP_RUNNING="false"
  BOOST_LIST="/data/FastTurbo_Custom/boost_list_b.txt"
  FOREGROUND_APP=$(su -c dumpsys window | grep mFocusedApp)
  for CHECK_APP in $(cat $BOOST_LIST) ; do
   case $FOREGROUND_APP in *"$CHECK_APP"*)
    APP_RUNNING="true"
   esac
  done
  if [ $APP_RUNNING = "true" ] ; then
    if [ $APPBOOST_START != "true" ] ; then
	 APPBOOST_START="true"
     echo "[LOG][$(date +%T)] 检测到预设程序运行,APP BOOST生效." |  tee -a $LOG;
    fi
   echo "true" > /data/FastTurbo/SmartAI/app_boost
  else
   if [ $APPBOOST_START = "true" ] ; then
    APPBOOST_START="false"
    echo "[LOG][$(date +%T)] 检测到程序退出,APP BOOST已停止." |  tee -a $LOG;
   fi
   echo "false" > /data/FastTurbo/SmartAI/app_boost
  fi
  sleep 10
 done
fi
