#!/system/bin/sh
chmod 7777 /system/bin/chwrite
echo "[FastTurbo Smart Ability] V7.0 STABLE " > /data/FastTurbo/SmartAI/core_info.log
LOG="/data/FastTurbo/SmartAI/core_info.log"
echo "* time : $(date) 初始化 SmartAbility ... " |  tee -a $LOG;
#Get Info------------------------------------------------------
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
case $SOC in mt*)
MTK="true"
esac
JP_FUNCTION=$(cat /data/FastTurbo/jp_function)
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
soc_special=$(cat /data/FastTurbo/SmartAI/soc_special)
mode=$(cat /data/FastTurbo/mode)
if [ $core_num = "9" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
freq8=$(cat /data/FastTurbo/SmartAI/cpu_freq8)
freq9=$(cat /data/FastTurbo/SmartAI/cpu_freq9)
elif [ $core_num = "7" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
elif [ $core_num = "5" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
elif [ $core_num = "3" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies ] ; then
available_freq_1=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies ] ; then
available_freq_2=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies ] ; then
available_freq_3=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies ] ; then
available_freq_4=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies ] ; then
available_freq_5=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies ] ; then
available_freq_a=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies)
fi
mode=$(cat /data/FastTurbo/mode)
k_mode=$(cat /data/FastTurbo/kmode)
ZRAM=$(cat /data/FastTurbo/zmode)
use_eas=$(cat /data/FastTurbo/use_eas)
smai_mode=$(cat /data/FastTurbo/smai_mode)
ram_fix=$(cat /data/FastTurbo/ram_fix)
#---------------------------------------------------------------
if [ $mode = "turbo" ] ; then 
echo "* Turbo模式温度监控已启动." |  tee -a $LOG;
echo "* Turbo模式温控 SOC:60°C/70°C , 电池:50°C." |  tee -a $LOG;
elif [ $mode = "balance" ] ; then
echo "* Balance模式温度监控已启动." |  tee -a $LOG;
echo "* Balance模式温控 SOC:50°C/60°C , 电池:45°C." |  tee -a $LOG;
elif [ $mode = "powersave" ] ; then
echo "* PowerSave模式温度监控已启动." |  tee -a $LOG;
echo "* PowerSave模式温控 SOC:45°C/55°C , 电池:40°C." |  tee -a $LOG;
elif [ $mode = "gamexe" ] ; then
echo "[ Game X Extreme 电竞模式已开启 ]" |  tee -a $LOG;
fi
echo " " |  tee -a $LOG;
STOP_SA_DAEMON="false"
while true ; do
SCREEN_STATE=$(su -c dumpsys window policy | grep screenState )
SCREEN_OFF="false"
case $SCREEN_STATE in *"SCREEN_STATE_OFF"*)
SCREEN_OFF="true"
esac
case $SCREEN_STATE in *"1"*)
SCREEN_OFF="true"
esac
if [ $SCREEN_OFF = "true" ] ; then
if [ $STOP_SA_DAEMON = "false" ] ; then
echo "[LOG][$(date +%T)] 监测到系统进入熄屏状态,已暂停SmartAbility." |  tee -a $LOG;
fi
STOP_SA_DAEMON="true"
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "0" ] ; then
   chwrite "1" "/proc/hps/enabled"
  fi
 fi
fi
else
if [ $STOP_SA_DAEMON = "true" ] ; then
STOP_SA_DAEMON="false"
echo "[LOG][$(date +%T)] 监测到系统退出熄屏状态,已重启SmartAbility." |  tee -a $LOG;
fi
JP_FUNCTION=$(cat /data/FastTurbo/jp_function)
SOC_TEMP1="0"
SOC_TEMP2="0"
SOC_TEMP3="0"
SOC_TEMP4="0"
SOC_TEMP5="0"
SOC_TEMP6="0"
SOC_TEMP7="0"
SOC_TEMP8="0"
SOC_TEMP9="0"
SOC_TEMP10="0"
if [ -e /sys/class/thermal/thermal_zone0/temp ] ; then
SOC_TEMP1=$(cat /sys/class/thermal/thermal_zone0/temp)
fi
if [ -e /sys/class/thermal/thermal_zone1/temp ] ; then
SOC_TEMP2=$(cat /sys/class/thermal/thermal_zone1/temp)
fi
if [ -e /sys/class/thermal/thermal_zone2/temp ] ; then
SOC_TEMP3=$(cat /sys/class/thermal/thermal_zone2/temp)
fi
if [ -e /sys/class/thermal/thermal_zone3/temp ] ; then
SOC_TEMP4=$(cat /sys/class/thermal/thermal_zone3/temp)
fi
if [ -e /sys/class/thermal/thermal_zone4/temp ] ; then
SOC_TEMP5=$(cat /sys/class/thermal/thermal_zone4/temp)
fi
if [ -e /sys/class/thermal/thermal_zone5/temp ] ; then
SOC_TEMP6=$(cat /sys/class/thermal/thermal_zone5/temp)
fi
if [ -e /sys/class/thermal/thermal_zone6/temp ] ; then
SOC_TEMP7=$(cat /sys/class/thermal/thermal_zone6/temp)
fi
if [ -e /sys/class/thermal/thermal_zone7/temp ] ; then
SOC_TEMP8=$(cat /sys/class/thermal/thermal_zone7/temp)
fi
if [ -e /sys/class/thermal/thermal_zone8/temp ] ; then
SOC_TEMP9=$(cat /sys/class/thermal/thermal_zone8/temp)
fi
if [ -e /sys/class/thermal/thermal_zone9/temp ] ; then
SOC_TEMP10=$(cat /sys/class/thermal/thermal_zone9/temp)
fi
SOC_TEMP="0"
for i in $SOC_TEMP1 $SOC_TEMP2 $SOC_TEMP3 $SOC_TEMP4 $SOC_TEMP5 $SOC_TEMP6 $SOC_TEMP7 $SOC_TEMP8 $SOC_TEMP9 $SOC_TEMP10 ; do  
  if [ ${i} -gt ${SOC_TEMP} ] ; then
   SOC_TEMP=$(echo ${i})
  fi
done
THERMAL_VALUE_LEN=`echo ${#SOC_TEMP}`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 if [ $mode = "turbo" ] ; then
   MAX_OVERTEMP="70000"
   MIN_OVERTEMP="60000"
   BATT_OVERTEMP="500"
 elif [ $mode = "balance" ] ; then
  MAX_OVERTEMP="60000"
  MIN_OVERTEMP="50000"
  BATT_OVERTEMP="450"
 elif [ $mode = "powersave" ] ; then
  MAX_OVERTEMP="55000"
  MIN_OVERTEMP="45000"
  BATT_OVERTEMP="400"
 fi
else
 if [ $mode = "turbo" ] ; then
   MAX_OVERTEMP="70"
   MIN_OVERTEMP="60"
   BATT_OVERTEMP="500"
 elif [ $mode = "balance" ] ; then
  MAX_OVERTEMP="60"
  MIN_OVERTEMP="50"
  BATT_OVERTEMP="450"
 elif [ $mode = "powersave" ] ; then
  MAX_OVERTEMP="55"
  MIN_OVERTEMP="45"
  BATT_OVERTEMP="400"
 fi
fi
if [ -d /sys/class/power_supply/battery/ ] ; then
BATT_TEMP=$(cat /sys/class/power_supply/battery/temp)
elif [ -d /sys/class/power_supply/Battery/ ] ; then
BATT_TEMP=$(cat /sys/class/power_supply/Battery/temp)
fi
if [ ${SOC_TEMP} -gt ${MAX_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "2" ] ; then
OVERTEMP_INFO=`echo $(($SOC_TEMP-$MIN_OVERTEMP))`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/1000))°C,已改变调度策略." |  tee -a $LOG;
else
 echo "[LOG][$(date +%T)] 监测到温度超过阈值 $OVERTEMP_INFO °C,已改变调度策略." |  tee -a $LOG;
fi
fi
OVERTEMP_LEVEL="2"
echo "2" > /data/FastTurbo/SmartAI/overtemp_level
elif [ ${SOC_TEMP} -gt ${MIN_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "1" ] ; then
OVERTEMP_INFO=`echo $(($SOC_TEMP-$MIN_OVERTEMP))`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/1000))°C,已改变调度策略." |  tee -a $LOG;
else
 echo "[LOG][$(date +%T)] 监测到温度超过阈值 $OVERTEMP_INFO °C,已改变调度策略." |  tee -a $LOG;
fi
fi
OVERTEMP_LEVEL="1"
echo "1" > /data/FastTurbo/SmartAI/overtemp_level
else
if [ $OVERTEMP_LEVEL != "0" ] ; then
echo "[LOG][$(date +%T)] 监测到温度恢复正常,已还原默认调度策略." |  tee -a $LOG;
fi
OVERTEMP_LEVEL="0"
echo "0" > /data/FastTurbo/SmartAI/overtemp_level
fi
if [ ${BATT_TEMP} -gt ${BATT_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "1" ] ; then
OVERTEMP_INFO=`echo $(($BATT_TEMP-$BATT_OVERTEMP))`
echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/10))°C,已改变调度策略." |  tee -a $LOG;
fi
OVERTEMP_LEVEL="1"
echo "1" > /data/FastTurbo/SmartAI/overtemp_level
fi
if [ $OVERTEMP_LEVEL = "1" ] ; then
   chwrite "0" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   chwrite "0" "/dev/stune/top-app/schedtune.boost"
   chwrite "0" "/dev/stune/foreground/schedtune.boost"
   chwrite "0" "/dev/stune/rt/schedtune.boost"
 if [ $mode != "powersave" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
  chwrite "3" /proc/sys/kernel/sched_spill_nr_run
 fi
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "60" /proc/sys/kernel/sched_spill_load
 fi
 fi
elif [ $OVERTEMP_LEVEL = "2" ] ; then
 chwrite "0" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
 chwrite "0" "/dev/stune/top-app/schedtune.boost"
 chwrite "0" "/dev/stune/foreground/schedtune.boost"
 chwrite "0" "/dev/stune/rt/schedtune.boost"
 GPU_DIR=$(cat /data/FastTurbo/SmartAI/gpu_dir)
 GPU_SUB=$(cat /data/FastTurbo/SmartAI/gpu_sub)
 if [ $GPU_SUB = "adreno" ] ; then
  if [ -e $GPU_DIR/max_pwrlevel ] ; then
   MAX_POWERLEVEL_INFO=$(cat /data/FastTurbo/SmartAI/adreno_maxpwrlevel)
   MAX_POWERLEVEL=$(cat $GPU_DIR/max_pwrlevel)
   ADRENOBOOST_INFO=$(cat /data/FastTurbo/SmartAI/adreno_boost)
   GPU_HIGH=$(cat $GPU_DIR/num_pwrlevels)
   if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
    ADRENOBOOST=$(cat $GPU_DIR/devfreq/adrenoboost)
   fi
   if [ $OVERTEMP_LEVEL = "2" ] ; then
    if [ ${GPU_HIGH} -lt 6 ] ; then 
     chwrite "$(($MAX_POWERLEVEL_INFO + 1))" "$GPU_DIR/max_pwrlevel"
    else
     chwrite "$(($MAX_POWERLEVEL_INFO + 2))" "$GPU_DIR/max_pwrlevel"
    fi
	if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
     chwrite "0" "$GPU_DIR/devfreq/adrenoboost"
    fi
   fi
  fi
 fi
 if [ $mode != "powersave" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
  chwrite "3" /proc/sys/kernel/sched_spill_nr_run
 fi
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "60" /proc/sys/kernel/sched_spill_load
 fi
 fi
 if [ $mode != "powersave" -a $JP_FUNCTION = "unsupport" ] ; then
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online" 
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online"
  fi
 fi
 elif [ $mode = "powersave" -a $JP_FUNCTION = "support" ] ; then
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online" 
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online"
  fi
 fi
 elif [ $mode = "powersave" -a $JP_FUNCTION = "unsupport" ] ; then
 if [ $core_num = "9" ] ; then
 chwrite "0-9" /dev/cpuset/foreground/cpus 
 chwrite "0-9" /dev/cpuset/top-app/cpus 
 chwrite "0-9" /dev/cpuset/game/cpus 
elif [ $core_num = "7" ] ; then
 chwrite "0-7" /dev/cpuset/foreground/cpus 
 chwrite "0-7" /dev/cpuset/top-app/cpus 
 chwrite "0-7" /dev/cpuset/game/cpus 
elif [ $core_num = "5" ] ; then
 chwrite "0-5" /dev/cpuset/foreground/cpus 
 chwrite "0-5" /dev/cpuset/top-app/cpus 
 chwrite "0-5" /dev/cpuset/game/cpus 
elif [ $core_num = "3" ] ; then
 chwrite "0-3" /dev/cpuset/foreground/cpus 
 chwrite "0-3" /dev/cpuset/top-app/cpus 
 chwrite "0-3" /dev/cpuset/game/cpus 
fi
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online"
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
  fi
 fi
 elif [ $mode != "powersave" -a $JP_FUNCTION = "support" ] ; then
 echo "true" > /data/FastTurbo/now_jp
if [ $core_num = "7" ] ; then
if [ $soc_special = "0" ] ; then
if [ ${freq0} -gt ${freq4} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "1" ] ; then
#2big,6little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu6" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "3" ] ; then
#1big,3mid,4little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu1" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "5" ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_3}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq
echo "cpu8" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "3" ] ; then
if [ $soc_special = "0" ] ; then
if [ $SOC = "msm8996" ] ; then
if [ ${freq0} -gt ${freq3} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu2" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
else
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
fi
fi
fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
if [ $mode != "powersave" ] ; then
echo "false" > /data/FastTurbo/now_jp
if [ $core_num = "9" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
chwrite $freq8 "/sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq"
chwrite $freq9 "/sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq"
elif [ $core_num = "7" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
elif [ $core_num = "5" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
elif [ $core_num = "3" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
fi
fi
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "1" ] ; then
   chwrite "0" "/proc/hps/enabled"
  fi
 fi
fi
if [ $core_num = "9" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU6_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu6_online)
CPU7_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu7_online)
CPU8_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu8_online)
CPU9_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu9_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
CPU6_ONLINE=$(cat /sys/devices/system/cpu/cpu6/online)
CPU7_ONLINE=$(cat /sys/devices/system/cpu/cpu7/online)
CPU8_ONLINE=$(cat /sys/devices/system/cpu/cpu8/online)
CPU9_ONLINE=$(cat /sys/devices/system/cpu/cpu9/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
if [ ${CPU6_ONLINE} != ${CPU6_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU6_ONLINE_INFO" "/sys/devices/system/cpu/cpu6/online"
fi
if [ ${CPU7_ONLINE} != ${CPU7_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU7_ONLINE_INFO" "/sys/devices/system/cpu/cpu7/online"
fi
if [ ${CPU8_ONLINE} != ${CPU8_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU8_ONLINE_INFO" "/sys/devices/system/cpu/cpu8/online"
fi
if [ ${CPU9_ONLINE} != ${CPU9_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU9_ONLINE_INFO" "/sys/devices/system/cpu/cpu9/online"
fi
elif [ $core_num = "7" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU6_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu6_online)
CPU7_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu7_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
CPU6_ONLINE=$(cat /sys/devices/system/cpu/cpu6/online)
CPU7_ONLINE=$(cat /sys/devices/system/cpu/cpu7/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
if [ ${CPU6_ONLINE} != ${CPU6_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU6_ONLINE_INFO" "/sys/devices/system/cpu/cpu6/online"
fi
if [ ${CPU7_ONLINE} != ${CPU7_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU7_ONLINE_INFO" "/sys/devices/system/cpu/cpu7/online"
fi
elif [ $core_num = "5" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
elif [ $core_num = "3" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
fi
#Check GPU Governor
GPU_DIR=$(cat /data/FastTurbo/SmartAI/gpu_dir)
GPU_SUB=$(cat /data/FastTurbo/SmartAI/gpu_sub)
if [ $GPU_SUB = "mali" ] ; then
 if [ -e $GPU_DIR/devfreq/gpufreq/governor ] ; then
 GPU_GOV=$(cat $GPU_DIR/devfreq/gpufreq/governor)
 if [ $GPU_GOV != "mali_ondemand" ] ; then
  KERNEL_CHANGED="true"
  chwrite "mali_ondemand" $GPU_DIR/devfreq/gpufreq/governor
 fi
 fi
else
if [ -e $GPU_DIR/devfreq/governor ] ; then
 GPU_GOV=$(cat $GPU_DIR/devfreq/governor)
 if [ $GPU_GOV != "simple_ondemand" ] ; then
  KERNEL_CHANGED="true"
  chwrite "simple_ondemand" $GPU_DIR/devfreq/governor
 fi
 fi
fi
#Check Adreno MAX Powerlevel & AdrenoBoost 
if [ $GPU_SUB = "adreno" ] ; then
if [ -e $GPU_DIR/max_pwrlevel ] ; then
MAX_POWERLEVEL_INFO=$(cat /data/FastTurbo/SmartAI/adreno_maxpwrlevel)
MAX_POWERLEVEL=$(cat $GPU_DIR/max_pwrlevel)
ADRENOBOOST_INFO=$(cat /data/FastTurbo/SmartAI/adreno_boost)
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
ADRENOBOOST=$(cat $GPU_DIR/devfreq/adrenoboost)
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
 if [ ${MAX_POWERLEVEL} -ne ${MAX_POWERLEVEL_INFO} ] ; then
 KERNEL_CHANGED="true"
 chwrite "$MAX_POWERLEVEL_INFO" "$GPU_DIR/max_pwrlevel"
 fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
 if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
  if [ ${ADRENOBOOST} -ne ${ADRENOBOOST_INFO} ] ; then
   chwrite "$ADRENOBOOST_INFO" "$GPU_DIR/devfreq/adrenoboost"
  fi
 fi
fi
fi
fi
#Check Mali GPU 
if [ $GPU_SUB = "mali" ] ; then
if [ -e $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold ] ; then
VSYNCUP_INFO=$(cat /data/FastTurbo/SmartAI/mali_vsync_up)
VSYNCDOWN_INFO=$(cat /data/FastTurbo/SmartAI/mali_vsync_down)
NO_VSYNCUP_INFO=$(cat /data/FastTurbo/SmartAI/mali_novsync_up)
NO_VSYNCDOWN_INFO=$(cat /data/FastTurbo/SmartAI/mali_novsync_down)
VSYNCUP=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold)
VSYNCDOWN=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential)
NO_VSYNCUP=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold)
NO_VSYNCDOWN=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential)
if [ ${VSYNCUP} -ne ${VSYNCUP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$VSYNCUP_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold"
fi
if [ ${VSYNCDOWN} -ne ${VSYNCDOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$VSYNCDOWN_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential"
fi
if [ ${NO_VSYNCUP} -ne ${NO_VSYNCUP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$NO_VSYNCUP_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold"
fi
if [ ${NO_VSYNCDOWN} -ne ${NO_VSYNCDOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "NO_VSYNCDOWN_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential"
fi
fi
fi
#Check TCP
TCP=$(cat /proc/sys/net/ipv4/tcp_congestion_control)
if [ $TCP != "cubic" ] ; then
KERNEL_CHANGED="true"
sysctl -e -w net.ipv4.tcp_congestion_control="cubic"
fi
#Check Dvfs
if [ -e /proc/mali/dvfs_enable ] ; then
DVFS_ENABLE=$(cat /proc/mali/dvfs_enable)
if [ $DVFS_ENABLE != "1" ] ; then
KERNEL_CHANGED="true"
chwrite "1" "/proc/mali/dvfs_enable"
fi
fi
#Check CPU Governor
CPU_GOV_INFO=$(cat /data/FastTurbo/SmartAI/cpu_governor)
CPU_GOV=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor)
if [ "$CPU_GOV" != "$CPU_GOV_INFO" ] ; then
KERNEL_CHANGED="true"
if [ $core_num = "9" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu8/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu9/cpufreq/scaling_governor
elif [ $core_num = "7" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor
elif [ $core_num = "5" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor
elif [ $core_num = "3" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor
fi
fi
#CPUSET CHECK
if [ -e /dev/cpuset/background/cpus ] ; then
CPUSET_BACKGROUND_INFO=$(cat /data/FastTurbo/SmartAI/background_cpus)
CPUSET_SYSBACKGROUND_INFO=$(cat /data/FastTurbo/SmartAI/sys_background_cpus)
CPUSET_FOREGROUND_INFO=$(cat /data/FastTurbo/SmartAI/foreground_cpus)
CPUSET_TOPAPP_INFO=$(cat /data/FastTurbo/SmartAI/topapp_cpus)
CPUSET_GAME_INFO=$(cat /data/FastTurbo/SmartAI/game_cpus)
CPUSET_BACKGROUND=$(cat /dev/cpuset/background/cpus)
CPUSET_SYSBACKGROUND=$(cat /dev/cpuset/system-background/cpus)
CPUSET_FOREGROUND=$(cat /dev/cpuset/foreground/cpus)
CPUSET_TOPAPP=$(cat /dev/cpuset/top-app/cpus)
CPUSET_GAME=$(cat /dev/cpuset/game/cpus)
CPUSET_TOPAPP_BOOST=$(cat /dev/cpuset/top-app/boost/cpus)
CPUSET_FOREGROUND_BOOST=$(cat /dev/cpuset/foreground/boost/cpus)
if [ $OVERTEMP_LEVEL = "0" -a $GAME_BOOST = "false" ] ; then
if [ "$CPUSET_BACKGROUND" != "$CPUSET_BACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_BACKGROUND_INFO" "/dev/cpuset/background/cpus"
fi
if [ "$CPUSET_SYSBACKGROUND" != "$CPUSET_SYSBACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_SYSBACKGROUND_INFO" "/dev/cpuset/system-background/cpus"
fi
if [ "$CPUSET_FOREGROUND" != "$CPUSET_BACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_FOREGROUND_INFO" "/dev/cpuset/foreground/cpus"
fi
if [ "$CPUSET_TOPAPP" != "$CPUSET_TOPAPP_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_TOPAPP_INFO" "/dev/cpuset/top-app/cpus"
fi
if [ "$CPUSET_GAME" != "$CPUSET_GAME_INFO" ] ; then
chwrite "$CPUSET_GAME_INFO" "/dev/cpuset/game/cpus"
fi
   if [ $core_num = "9" ] ; then
    if [ ${freq0} -gt ${freq9} ] ; then
	 if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	 chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	 fi
	 if [ "$CPUSET_TOPAPP_BOOST" != "0-9" ] ; then
	 chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
	 fi
	else
	 if [ "$CPUSET_FOREGROUND_BOOST" != "8-9" ] ; then
	 chwrite "8-9" /dev/cpuset/foreground/boost/cpus 
	 fi
	 if [ "$CPUSET_TOPAPP_BOOST" != "0-9" ] ; then
	 chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
	 fi
	fi
   elif [ $core_num = "7" ] ; then
	if [ $soc_special = "0" ] ; then
	 if [ ${freq0} -gt ${freq7} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "4-7" ] ; then
	  chwrite "4-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 fi
	elif [ $soc_special = "1" ] ; then
	 if [ ${freq0} -gt ${freq7} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "6-7" ] ; then
	  chwrite "6-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 fi
	elif [ $soc_special = "5" ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   elif [ $core_num = "5" ] ; then
	if [ ${freq0} -gt ${freq5} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "4-5" ] ; then
	  chwrite "4-5" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   elif [ $core_num = "3" ] ; then
    if [ $soc_special != "0" ] ; then
	if [ ${freq0} -gt ${freq3} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
	  fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "2-3" ] ; then
	  chwrite "2-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-3" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   fi
fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
if [ -e /proc/sys/kernel/sched_downmigrate ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
SCHED_UP=$(cat /proc/sys/kernel/sched_upmigrate)
SCHED_DOWN=$(cat /proc/sys/kernel/sched_downmigrate)
if [ ${SCHED_UP} -ne ${SCHED_UP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_UP_INFO" "/proc/sys/kernel/sched_upmigrate"
fi
if [ ${SCHED_DOWN} -ne ${SCHED_DOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_DOWN_INFO" "/proc/sys/kernel/sched_downmigrate"
fi
fi
if [ -e /proc/hps/up_threshold ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
THRES_UP=$(cat /proc/hps/up_threshold)
THRES_DOWN=$(cat /proc/hps/down_threshold)
if [ ${THRES_UP} -ne ${SCHED_UP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_UP_INFO" "/proc/hps/up_threshold"
fi
if [ ${THRES_DOWN} -ne ${SCHED_DOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_DOWN_INFO" "/proc/hps/down_threshold"
fi
fi
else
if [ -e /proc/sys/kernel/sched_downmigrate ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
chwrite "$(($SCHED_UP_INFO+10))" "/proc/sys/kernel/sched_upmigrate" 
chwrite "$(($SCHED_DOWN_INFO+10))" "/proc/sys/kernel/sched_downmigrate"
fi
if [ -e /proc/hps/up_threshold ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
chwrite "$(($SCHED_UP_INFO+10))" "/proc/hps/up_threshold" 
chwrite "$(($SCHED_DOWN_INFO+10))" "/proc/hps/down_threshold"
fi
fi
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
NR_RUN=$(cat /proc/sys/kernel/sched_spill_nr_run)
fi
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
SPILL_LOAD=$(cat /proc/sys/kernel/sched_spill_load)
fi
if [ $mode != "powersave" ] ; then
 if [ $OVERTEMP_LEVEL = "0" ] ; then
  if [ ${NR_RUN} -ne "3" ] ; then
   if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
    chwrite "10" /proc/sys/kernel/sched_spill_nr_run
   fi
  fi
if [ ${SPILL_LOAD} -ne "60" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "85" /proc/sys/kernel/sched_spill_load
 fi
fi
fi
else
if [ ${NR_RUN} -ne "3" ] ; then
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
chwrite "3" /proc/sys/kernel/sched_spill_nr_run
fi
fi
if [ ${SPILL_LOAD} -ne "60" ] ; then
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
chwrite "60" /proc/sys/kernel/sched_spill_load
fi
fi
fi
if [ -e /dev/stune/top-app/schedtune.boost ] ; then
DYNAMIC_BOOST=$(cat /sys/module/cpu_boost/parameters/dynamic_stune_boost)
TOPAPP_BOOST=$(cat /dev/stune/top-app/schedtune.boost)
FOREGROUND_BOOST=$(cat /dev/stune/foreground/schedtune.boost)
BACKGROUND_BOOST=$(cat /dev/stune/background/schedtune.boost)
 if [ $OVERTEMP_LEVEL = "0" ] ; then
  DYNAMIC_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/dynamic_boost)
  TOPAPP_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/topapp_boost)
  FOREGROUND_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/foreground_boost)
  RT_BOOST_NOW=$(cat /dev/stune/rt/schedtune.boost)
  if [ $GAME_BOOST = "true" ] ; then
   if [ $mode = "gamexe" ] ; then
    chwrite "50" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
    chwrite "50" "/dev/stune/top-app/schedtune.boost"
    chwrite "40" "/dev/stune/foreground/schedtune.boost"
    chwrite "40" "/dev/stune/rt/schedtune.boost"
   else
    chwrite "40" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
    chwrite "40" "/dev/stune/top-app/schedtune.boost"
    chwrite "30" "/dev/stune/foreground/schedtune.boost"
    chwrite "30" "/dev/stune/rt/schedtune.boost"
   fi
  else
   if [ "$DYNAMIC_BOOST" != "$DYNAMIC_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$DYNAMIC_BOOST_INFO" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   fi
   if [ "$TOPAPP_BOOST" != "$TOPAPP_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$TOPAPP_BOOST_INFO" "/dev/stune/top-app/schedtune.boost"
   fi
   if [ "$FOREGROUND_BOOST" != "$FOREGROUND_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$FOREGROUND_BOOST_INFO" "/dev/stune/foreground/schedtune.boost"
   fi
   if [ "$RT_BOOST_NOW" != "10" ] ; then
    chwrite "10" "/dev/stune/rt/schedtune.boost"
   fi
  fi 
 fi
 BACKGROUND_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/background_boost)
 if [ "$BACKGROUND_BOOST" != "$BACKGROUND_BOOST_INFO" ] ; then
  KERNEL_CHANGED="true"
  chwrite "$BACKGROUND_BOOST_INFO" "/dev/stune/background/schedtune.boost)"
 fi
fi
CHECK_CPU=$(cat /data/FastTurbo/SmartAI/pwrsv_check)
CHECK_FREQ_INFO=$(cat /data/FastTurbo/SmartAI/pwrsv_freq)
FREQ_CHANGED="false"
if [ $NOW_JP = "true" ] ; then
if [ $JP_FUNCTION = "support" ] ; then
if [ $CHECK_CPU = "cpu0" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu1" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu2" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu3" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu4" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu5" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu6" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu7" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu8" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu9" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
fi
if [ $FREQ_CHANGED = "true" ] ; then
if [ ${CHANGED_COUNT} -lt 5 ] ; then
CHANGED_COUNT=`echo $(($CHANGED_COUNT+1))`
else
echo "unsupport" > /data/FastTurbo/jp_function
JP_FUNCTION="unsupport"
fi
fi
fi
fi
fi
fi
MODE_NOW=$(cat /data/FastTurbo/mode)
KMODE_NOW=$(cat /data/FastTurbo/kmode)
ZRAM_NOW=$(cat /data/FastTurbo/zmode)
EAS_NOW=$(cat /data/FastTurbo/use_eas)
SA_NOW=$(cat /data/FastTurbo/smai_mode)
RAM_NOW=$(cat /data/FastTurbo/ram_fix)
if [ "$RAM_NOW" != "$ram_fix" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$MODE_NOW" != "$mode" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$KMODE_NOW" != "$k_mode" ] ; then
chmod 7777 /system/etc/init.ft.ram.sh
su -c sh /system/etc/init.ft.ram.sh &
fi
if [ "$ZRAM_NOW" != "$ZRAM" ] ; then
chmod 7777 /system/etc/init.ft.ram.sh
su -c sh /system/etc/init.ft.ram.sh &
fi
if [ "$EAS_NOW" != "$use_eas" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$SA_NOW" != "$smai_mode" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
sleep 10
done

