#!/system/bin/sh
#修改关键配置文件权限
umask 002
MODDIR=${0%/*}
echo "$MODDIR" > /data/FastTurbo/moddir
chmod 7777 /system/bin/chwrite
chmod -R 7777 /data/FastTurbo/ 
if [ -e /data/FastTurbo/done ] ; then
 done_value=$(cat /data/FastTurbo/done)
fi
echo "0" > /data/FastTurbo/done 
if [ ! -d /data/FastTurbo/SmartAI/ ] ; then
 mkdir -p /data/FastTurbo/SmartAI/
fi
LOG=/data/FastTurbo/FastTurbo.log
#SmartCore II--------------------------------------------------------------------
if [ ! -d /data/FastTurbo/SmartCore_Files/ ] ; then  #Get system information.
echo "[SmartCore] 首次使用,获取系统信息中..." > /data/FastTurbo/FastTurbo.log
mkdir -p /data/FastTurbo/SmartCore_Files  #Make Information Dir.
INFO_DIR="/data/FastTurbo/SmartCore_Files"  
 if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor ] ; then  #Get Defult CPU Governor.
  CPU_GOVERNOR=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor)
  echo "$CPU_GOVERNOR" > $INFO_DIR/cpu_governor
 fi
echo "[SmartCore] 系统信息获取成功！" |  tee -a $LOG;
else
echo "[SmartCore] 数据读取成功！" > /data/FastTurbo/FastTurbo.log
fi
#正常开机计数--------------------------------------------------------------------
if [ ! -e /data/FastTurbo/use_count ] ; then
 echo "0" > /data/FastTurbo/use_count
 chmod 0444 /data/FastTurbo/use_count
 USE_COUNT="0"
else
 USE_COUNT=$(cat /data/FastTurbo/use_count)
 NEW_USECOUNT=$(($USE_COUNT+1))
 chmod 0666 /data/FastTurbo/use_count
 echo "$NEW_USECOUNT" > /data/FastTurbo/use_count
 chmod 0444 /data/FastTurbo/use_count
fi
echo "* FastTurbo 正常启动次数: $(($USE_COUNT+1)) 次." |  tee -a $LOG;
core_num=$(cat /sys/devices/system/cpu/kernel_max)
if [ $core_num = "9" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
chwrite 1 /sys/devices/system/cpu/cpu6/online 
chwrite 1 /sys/devices/system/cpu/cpu7/online 
chwrite 1 /sys/devices/system/cpu/cpu8/online 
chwrite 1 /sys/devices/system/cpu/cpu9/online 
elif [ $core_num = "7" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
chwrite 1 /sys/devices/system/cpu/cpu6/online 
chwrite 1 /sys/devices/system/cpu/cpu7/online 
elif [ $core_num = "5" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
chwrite 1 /sys/devices/system/cpu/cpu1/online  
chwrite 1 /sys/devices/system/cpu/cpu2/online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
elif [ $core_num = "3" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
fi
#--------------------------------------------------------------------------------
if [ $done_value = "0" ] ; then
 echo "* FastTurbo 检测到上次运行时存在错误,已自动中止." |  tee -a $LOG;
 echo "* 请重刷FastTurbo模块以消除可能存在的错误." |  tee -a $LOG;
 echo "* 如果问题仍然无法解决,请联系作者." |  tee -a $LOG;
 exit 0
fi
echo "false" > /data/FastTurbo/now_jp
mode=$(cat /data/FastTurbo/mode)
if [ $mode = "gamexe" ] ; then  #重启禁用GameXE
 echo "balance" > /data/FastTurbo/mode
fi
if [ -e /system/etc/init.ft.main.sh ] ; then
 su_ver=$(su -v)
 echo "* SU Verison: $su_ver" |  tee -a $LOG;
 chmod 7777 /system/etc/init.ft.main.sh
 su -c sh /system/etc/init.ft.main.sh
else
 echo "* FastTurbo 检测到位于/system/的主程序丢失,已自动中止." > /data/FastTurbo/FastTurbo.log
 echo "* 请重刷FastTurbo模块以消除可能存在的错误." |  tee -a $LOG;
 echo "* 如果问题仍然无法解决,请联系作者." |  tee -a $LOG;
 exit 0
fi
