#!/system/bin/sh
mode=$(cat /data/FastTurbo/mode)
k_mode=$(cat /data/FastTurbo/kmode)
ZRAM=$(cat /data/FastTurbo/zmode)
use_eas=$(cat /data/FastTurbo/use_eas)
smai_mode=$(cat /data/FastTurbo/smai_mode)
ram_fix=$(cat /data/FastTurbo/ram_fix)
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
case $SOC in mt*)
MTK="true"
esac
while true ; do
MODE_NOW=$(cat /data/FastTurbo/mode)
KMODE_NOW=$(cat /data/FastTurbo/kmode)
ZRAM_NOW=$(cat /data/FastTurbo/zmode)
EAS_NOW=$(cat /data/FastTurbo/use_eas)
SA_NOW=$(cat /data/FastTurbo/smai_mode)
RAM_NOW=$(cat /data/FastTurbo/ram_fix)
SCREEN_STATE=$(su -c dumpsys window policy | grep screenState )
SCREEN_OFF="false"
case $SCREEN_STATE in *"SCREEN_STATE_OFF"*)
SCREEN_OFF="true"
esac
case $SCREEN_STATE in *"1"*)
SCREEN_OFF="true"
esac
if [ "$MODE_NOW" != "$mode" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$KMODE_NOW" != "$k_mode" ] ; then
chmod 7777 /system/etc/init.ft.ram.sh
su -c sh /system/etc/init.ft.ram.sh &
fi
if [ "$ZRAM_NOW" != "$ZRAM" ] ; then
chmod 7777 /system/etc/init.ft.ram.sh
su -c sh /system/etc/init.ft.ram.sh &
fi
if [ "$EAS_NOW" != "$use_eas" ] ; then
echo "$EAS_NOW" > /data/FastTurbo/SmartAI/last_use_eas
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$SA_NOW" != "$smai_mode" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ "$RAM_NOW" != "$ram_fix" ] ; then
echo "$(date) 检测到参数被修改" > /data/FastTurbo/FastTurbo.log
chmod 7777 /system/etc/init.ft.restart.sh
su -c sh /system/etc/init.ft.restart.sh
exit 0
fi
if [ $SCREEN_OFF = "true" ] ; then 
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "0" ] ; then
   chwrite "1" "/proc/hps/enabled"
  fi
 fi
fi
sleep 20
else
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "1" ] ; then
   chwrite "0" "/proc/hps/enabled"
  fi
 fi
fi
sleep 5
fi
done
#Powered by Chenzyadb