#!/system/bin/sh
THERMAL_PID=$$
echo "$THERMAL_PID" > /data/FastTurbo/SmartAI/thermal_pid
mode=$(cat /data/FastTurbo/mode)
LOG="/data/FastTurbo/SmartAI/core_info.log"
#Get Info------------------------------------------------------
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
MTK="false"
case $SOC in mt*)
MTK="true"
esac
JP_FUNCTION=$(cat /data/FastTurbo/jp_function)
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
soc_special=$(cat /data/FastTurbo/SmartAI/soc_special)
mode=$(cat /data/FastTurbo/mode)
if [ $core_num = "9" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
freq8=$(cat /data/FastTurbo/SmartAI/cpu_freq8)
freq9=$(cat /data/FastTurbo/SmartAI/cpu_freq9)
elif [ $core_num = "7" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
elif [ $core_num = "5" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
elif [ $core_num = "3" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies ] ; then
available_freq_1=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies ] ; then
available_freq_2=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies ] ; then
available_freq_3=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies ] ; then
available_freq_4=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies ] ; then
available_freq_5=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies ] ; then
available_freq_a=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies)
fi
#---------------------------------------------------------------
OVERTEMP_CHANGED="false"
OVERTEMP_LEVEL="0"
echo "0" > /data/FastTurbo/SmartAI/overtemp_level
while true ; do
GAME_BOOST_THERMAL=$(cat /data/FastTurbo/SmartAI/game_boost)
APP_BOOST_THERMAL=$(cat /data/FastTurbo/SmartAI/app_boost)
JP_FUNCTION=$(cat /data/FastTurbo/jp_function)
SOC_TEMP1="0"
SOC_TEMP2="0"
SOC_TEMP3="0"
SOC_TEMP4="0"
SOC_TEMP5="0"
SOC_TEMP6="0"
SOC_TEMP7="0"
SOC_TEMP8="0"
SOC_TEMP9="0"
SOC_TEMP10="0"
if [ -e /sys/class/thermal/thermal_zone0/temp ] ; then
SOC_TEMP1=$(cat /sys/class/thermal/thermal_zone0/temp)
fi
if [ -e /sys/class/thermal/thermal_zone1/temp ] ; then
SOC_TEMP2=$(cat /sys/class/thermal/thermal_zone1/temp)
fi
if [ -e /sys/class/thermal/thermal_zone2/temp ] ; then
SOC_TEMP3=$(cat /sys/class/thermal/thermal_zone2/temp)
fi
if [ -e /sys/class/thermal/thermal_zone3/temp ] ; then
SOC_TEMP4=$(cat /sys/class/thermal/thermal_zone3/temp)
fi
if [ -e /sys/class/thermal/thermal_zone4/temp ] ; then
SOC_TEMP5=$(cat /sys/class/thermal/thermal_zone4/temp)
fi
if [ -e /sys/class/thermal/thermal_zone5/temp ] ; then
SOC_TEMP6=$(cat /sys/class/thermal/thermal_zone5/temp)
fi
if [ -e /sys/class/thermal/thermal_zone6/temp ] ; then
SOC_TEMP7=$(cat /sys/class/thermal/thermal_zone6/temp)
fi
if [ -e /sys/class/thermal/thermal_zone7/temp ] ; then
SOC_TEMP8=$(cat /sys/class/thermal/thermal_zone7/temp)
fi
if [ -e /sys/class/thermal/thermal_zone8/temp ] ; then
SOC_TEMP9=$(cat /sys/class/thermal/thermal_zone8/temp)
fi
if [ -e /sys/class/thermal/thermal_zone9/temp ] ; then
SOC_TEMP10=$(cat /sys/class/thermal/thermal_zone9/temp)
fi
SOC_TEMP="0"
for i in $SOC_TEMP1 $SOC_TEMP2 $SOC_TEMP3 $SOC_TEMP4 $SOC_TEMP5 $SOC_TEMP6 $SOC_TEMP7 $SOC_TEMP8 $SOC_TEMP9 $SOC_TEMP10 ; do  
  if [ ${i} -gt ${SOC_TEMP} ] ; then
   SOC_TEMP=$(echo ${i})
  fi
done
THERMAL_VALUE_LEN=`echo ${#SOC_TEMP}`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 if [ $mode = "turbo" ] ; then
  if [ $GAME_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="80000"
   MIN_OVERTEMP="70000"
   BATT_OVERTEMP="550"
  else
   MAX_OVERTEMP="70000"
   MIN_OVERTEMP="60000"
   BATT_OVERTEMP="500"
  fi
 elif [ $mode = "balance" ] ; then
  if [ $APP_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="70000"
   MIN_OVERTEMP="60000"
   BATT_OVERTEMP="500"
  else
   MAX_OVERTEMP="60000"
   MIN_OVERTEMP="50000"
   BATT_OVERTEMP="450"
  fi
 elif [ $mode = "powersave" ] ; then
  if [ $APP_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="60000"
   MIN_OVERTEMP="50000"
   BATT_OVERTEMP="450"
  else
   MAX_OVERTEMP="55000"
   MIN_OVERTEMP="45000"
   BATT_OVERTEMP="400"
  fi
 fi
else
 if [ $mode = "turbo" ] ; then
  if [ $GAME_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="80"
   MIN_OVERTEMP="70"
   BATT_OVERTEMP="550"
  else
   MAX_OVERTEMP="70"
   MIN_OVERTEMP="60"
   BATT_OVERTEMP="500"
  fi
 elif [ $mode = "balance" ] ; then
  if [ $APP_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="70"
   MIN_OVERTEMP="60"
   BATT_OVERTEMP="450"
  else
   MAX_OVERTEMP="60"
   MIN_OVERTEMP="50"
   BATT_OVERTEMP="450"
  fi
 elif [ $mode = "powersave" ] ; then
  if [ $APP_BOOST_THERMAL = "true" ] ; then
   MAX_OVERTEMP="60"
   MIN_OVERTEMP="50"
   BATT_OVERTEMP="450"
  else
   MAX_OVERTEMP="55"
   MIN_OVERTEMP="45"
   BATT_OVERTEMP="400"
  fi
 fi
fi
if [ -d /sys/class/power_supply/battery/ ] ; then
BATT_TEMP=$(cat /sys/class/power_supply/battery/temp)
elif [ -d /sys/class/power_supply/Battery/ ] ; then
BATT_TEMP=$(cat /sys/class/power_supply/Battery/temp)
fi
if [ ${SOC_TEMP} -gt ${MAX_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "2" ] ; then
OVERTEMP_INFO=`echo $(($SOC_TEMP-$MIN_OVERTEMP))`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/1000))°C,已改变调度策略." |  tee -a $LOG;
else
 echo "[LOG][$(date +%T)] 监测到温度超过阈值 $OVERTEMP_INFO °C,已改变调度策略." |  tee -a $LOG;
fi
fi
OVERTEMP_LEVEL="2"
echo "2" > /data/FastTurbo/SmartAI/overtemp_level
elif [ ${SOC_TEMP} -gt ${MIN_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "1" ] ; then
OVERTEMP_INFO=`echo $(($SOC_TEMP-$MIN_OVERTEMP))`
if [ ${THERMAL_VALUE_LEN} -gt 3 ] ; then 
 echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/1000))°C,已改变调度策略." |  tee -a $LOG;
else
 echo "[LOG][$(date +%T)] 监测到温度超过阈值 $OVERTEMP_INFO °C,已改变调度策略." |  tee -a $LOG;
fi
fi
OVERTEMP_LEVEL="1"
echo "1" > /data/FastTurbo/SmartAI/overtemp_level
else
if [ $OVERTEMP_LEVEL != "0" ] ; then
echo "[LOG][$(date +%T)] 监测到温度恢复正常,已还原默认调度策略." |  tee -a $LOG;
fi
OVERTEMP_LEVEL="0"
echo "0" > /data/FastTurbo/SmartAI/overtemp_level
fi
if [ ${BATT_TEMP} -gt ${BATT_OVERTEMP} ] ; then
if [ $OVERTEMP_LEVEL != "1" ] ; then
OVERTEMP_INFO=`echo $(($BATT_TEMP-$BATT_OVERTEMP))`
echo "[LOG][$(date +%T)] 监测到温度超过阈值$(($OVERTEMP_INFO/10))°C,已改变调度策略." |  tee -a $LOG;
fi
OVERTEMP_LEVEL="1"
echo "1" > /data/FastTurbo/SmartAI/overtemp_level
fi
if [ $OVERTEMP_LEVEL = "1" ] ; then
 if [ $GAME_BOOST_THERMAL = "true" ] ; then
   chwrite "5" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   chwrite "5" "/dev/stune/top-app/schedtune.boost"
   chwrite "5" "/dev/stune/foreground/schedtune.boost"
   chwrite "5" "/dev/stune/rt/schedtune.boost"
  else
   chwrite "0" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   chwrite "0" "/dev/stune/top-app/schedtune.boost"
   chwrite "0" "/dev/stune/foreground/schedtune.boost"
   chwrite "0" "/dev/stune/rt/schedtune.boost"
 fi
 if [ $mode != "powersave" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
  chwrite "3" /proc/sys/kernel/sched_spill_nr_run
 fi
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "60" /proc/sys/kernel/sched_spill_load
 fi
 fi
elif [ $OVERTEMP_LEVEL = "2" ] ; then
 if [ $GAME_BOOST_THERMAL = "true" ] ; then
   chwrite "5" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   chwrite "5" "/dev/stune/top-app/schedtune.boost"
   chwrite "5" "/dev/stune/foreground/schedtune.boost"
   chwrite "5" "/dev/stune/rt/schedtune.boost"
  else
   chwrite "0" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   chwrite "0" "/dev/stune/top-app/schedtune.boost"
   chwrite "0" "/dev/stune/foreground/schedtune.boost"
   chwrite "0" "/dev/stune/rt/schedtune.boost"
 fi
 if [ $mode != "powersave" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
  chwrite "3" /proc/sys/kernel/sched_spill_nr_run
 fi
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "60" /proc/sys/kernel/sched_spill_load
 fi
 fi
 if [ $mode != "powersave" -a $JP_FUNCTION = "unsupport" ] ; then
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online" 
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online"
  fi
 fi
 elif [ $mode = "powersave" -a $JP_FUNCTION = "support" ] ; then
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online" 
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online"
  fi
 fi
 elif [ $mode = "powersave" -a $JP_FUNCTION = "unsupport" ] ; then
 if [ $core_num = "9" ] ; then
 chwrite "0-9" /dev/cpuset/foreground/cpus 
 chwrite "0-9" /dev/cpuset/top-app/cpus 
 chwrite "0-9" /dev/cpuset/game/cpus 
elif [ $core_num = "7" ] ; then
 chwrite "0-7" /dev/cpuset/foreground/cpus 
 chwrite "0-7" /dev/cpuset/top-app/cpus 
 chwrite "0-7" /dev/cpuset/game/cpus 
elif [ $core_num = "5" ] ; then
 chwrite "0-5" /dev/cpuset/foreground/cpus 
 chwrite "0-5" /dev/cpuset/top-app/cpus 
 chwrite "0-5" /dev/cpuset/game/cpus 
elif [ $core_num = "3" ] ; then
 chwrite "0-3" /dev/cpuset/foreground/cpus 
 chwrite "0-3" /dev/cpuset/top-app/cpus 
 chwrite "0-3" /dev/cpuset/game/cpus 
fi
  if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online"
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online"
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online"
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online"
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online"
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online"
   else
    chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online"
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
  fi
 fi
 elif [ $mode != "powersave" -a $JP_FUNCTION = "support" ] ; then
 echo "true" > /data/FastTurbo/now_jp
if [ $core_num = "7" ] ; then
if [ $soc_special = "0" ] ; then
if [ ${freq0} -gt ${freq4} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "1" ] ; then
#2big,6little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu6" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "3" ] ; then
#1big,3mid,4little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu1" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "5" ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_3}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq
echo "cpu8" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "3" ] ; then
if [ $soc_special = "0" ] ; then
if [ $SOC = "msm8996" ] ; then
if [ ${freq0} -gt ${freq3} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu2" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
else
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-32:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
fi
fi
fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
if [ $mode != "powersave" ] ; then
echo "false" > /data/FastTurbo/now_jp
if [ $core_num = "9" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
chwrite $freq8 "/sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq"
chwrite $freq9 "/sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq"
elif [ $core_num = "7" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
elif [ $core_num = "5" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
elif [ $core_num = "3" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
fi
fi
fi
sleep 5
done
